#include "kb.h"

#define _QWERTY 0
#define _LOWER 1
#define _RAISE 2
#define _CURSOR 3
#define _NUMPAD 4
#define _ADJUST 16

enum custom_keycodes {
  QWERTY = SAFE_RANGE,
  LOWER,
  RAISE,
  CURSOR,
  NUMPAD,
  ADJUST,
};

#define KC_LOWER MO(_LOWER)
#define KC_RAISE MO(_RAISE)
#define KC_CUR MO(_CURSOR)
#define KC_NUM MO(_NUMPAD)
#define KC_ADJUST MO(_ADJUST)
#define KC_RESET RESET
#define KC_SFL1 LSFT_T(KC_LANG1)
#define KC_SFL2 LSFT_T(KC_LANG2)
#define KC_ALTB LALT_T(KC_TAB)
#define KC_GUES LGUI_T(KC_ESC)
#define KC_CTLF LCTL(KC_LEFT)
#define KC_CTRT LCTL(KC_RIGHT)
#define KC_CMA LGUI(KC_A)
#define KC_CMZ LGUI(KC_Z)
#define KC_CMS LGUI(KC_S)
#define KC_CMX LGUI(KC_X)
#define KC_CMC LGUI(KC_C)
#define KC_CMV LGUI(KC_V)
#define KC_CMF LGUI(KC_F)
#define KC_SST SGUI(KC_4)
#define KC_CMPL LGUI(KC_PLUS)
#define KC_CMMN LGUI(KC_MINS)
#define KC_SUP LSFT(KC_UP)
#define KC_SDN LSFT(KC_DOWN)
#define KC_SLFT LSFT(KC_LEFT)
#define KC_SRGT LSFT(KC_RGHT)
#define KC_WLU LCAG(KC_1)
#define KC_WLS LCAG(KC_LEFT)
#define KC_WLD LCAG(KC_3)
#define KC_WRU LCAG(KC_2)
#define KC_WRS LCAG(KC_RGHT)
#define KC_WRD LCAG(KC_4)
#define KC_WFS LCAG(KC_M)

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {

[_QWERTY] = LAYOUT_kc(
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
	     Q,      W,      E,      R,      T,                   Y,      U,      I,      O,      P,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	     A,      S,      D,      F,      G,                   H,      J,      K,      L,   SCLN,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	     Z,      X,      C,      V,      B,                   N,      M,   COMM,    DOT,   SLSH,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  BSLS,    EQL,   SFL2,  LOWER,    SPC,                BSPC,  RAISE,   SFL1,   MINS,   RBRC,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          ALTB,   LCTL,                GUES,    ENT
//                        |-------+-------|            |-------+-------|
),

[_LOWER] = LAYOUT_kc(
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
         1,      2,      3,      4,      5,                   6,      7,      8,      9,      0,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
       CMA,    CMS,   TRNS,    CMF,   TRNS,                LEFT,   DOWN,     UP,   RGHT,   CMPL,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
       CMZ,    CMX,    CMC,    CMV,   TRNS,                HOME,   PGDN,   PGUP,    END,   CMMN,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	   CUR,    NUM,   TRNS,   TRNS,   LGUI,                TRNS, ADJUST,   TRNS,   CTLF,   CTRT,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          TRNS,  RESET,                TRNS,   TRNS
//                        |-------+-------|            |-------+-------|
),

[_RAISE] = LAYOUT_kc(
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
      EXLM,     AT,   HASH,    DLR,   LPRN,                RPRN,   AMPR,   ASTR,   PERC,   CIRC,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
       GRV,   MINS,   EQL ,   BSLS,   LBRC,                RBRC,   QUOT,   COMM,    DOT,   SCLN,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
      TILD,   UNDS,   PLUS,   PIPE,   LCBR,                RCBR,    DQT,     LT,     GT,   COLN,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  SLSH,   QUES,   TRNS, ADJUST,   TRNS,                TRNS,   TRNS,   TRNS,   TRNS,   TRNS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          TRNS,   TRNS,                TRNS,   TRNS
//                        |-------+-------|            |-------+-------|
),

[_CURSOR] = LAYOUT_kc(
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                SLFT,    SDN,    SUP,   SRGT,   TRNS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                LEFT,   DOWN,    UP ,   RGHT,   CMPL,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                MS_L,   MS_D,   MS_U,   MS_R,   CMMN,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,   TRNS,   PGDN,   PGUP,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          TRNS,   TRNS,                BTN1,   BTN2
//                        |-------+-------|            |-------+-------|
),

[_NUMPAD] = LAYOUT_kc(
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                ASTR,    P7 ,    P8 ,    P9 ,   PLUS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                SLSH,    P4 ,    P5 ,    P6 ,   MINS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                PERC,    P1 ,    P2 ,    P3 ,    EQL,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,   TRNS,    P0 ,    DOT,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          TRNS,   TRNS,                TRNS,   TRNS
//                        |-------+-------|            |-------+-------|
),

[_ADJUST] = LAYOUT_kc(
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
      WLU ,    F1 ,    F2 ,    F3 ,    F4 ,                SLFT,    SDN,    SUP,   SRGT,    WRU,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
      WLS ,    F5 ,    F6 ,    F7 ,    F8 ,                LEFT,   DOWN,    UP ,   RGHT,    WRS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
      WLD ,    F9 ,   F10 ,   F11 ,   F12 ,                HOME,   PGDN,   PGUP,    END,    WRD,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,    WFS,   TRNS,    SST,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          TRNS,  RESET,                TRNS,   TRNS
//                        |-------+-------|            |-------+-------|
),
};

bool process_record_user(uint16_t keycode, keyrecord_t *record) {
	return true;
}

// bool process_record_user(uint16_t keycode, keyrecord_t *record) {
//   switch (keycode) {
//     case QWERTY:
//       if (record->event.pressed) {
//         // persistant_default_layer_set(1UL<<_QWERTY);
//         set_single_persistent_default_layer(_QWERTY);
//       }
//       return false;
//       break;
//     case LOWER:
//       if (record->event.pressed) {
//         layer_on(_LOWER);
//         update_tri_layer(_LOWER, _RAISE, _ADJUST);
//       } else {
//         layer_off(_LOWER);
//         update_tri_layer(_LOWER, _RAISE, _ADJUST);
//       }
//       return false;
//       break;
//     case RAISE:
//       if (record->event.pressed) {
//         layer_on(_RAISE);
//         update_tri_layer(_LOWER, _RAISE, _ADJUST);
//       } else {
//         layer_off(_RAISE);
//         update_tri_layer(_LOWER, _RAISE, _ADJUST);
//       }
//       return false;
//       break;
//     case ADJUST:
//       if (record->event.pressed) {
//         layer_on(_ADJUST);
//       } else {
//         layer_off(_ADJUST);
//       }
//       return false;
//       break;
//   }
//   return true;
// }

void matrix_init_user(void) {
}

void matrix_scan_user(void) {
}

void led_set_user(uint8_t usb_led) {
}

/*
//,-------+-------+-------+-------+-------.            ,-------+-------+-------+-------+-------.
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,   TRNS,   TRNS,   TRNS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,   TRNS,   TRNS,   TRNS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,   TRNS,   TRNS,   TRNS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	  TRNS,   TRNS,   TRNS,   TRNS,   TRNS,                TRNS,   TRNS,   TRNS,   TRNS,   TRNS,
//|-------+-------+-------+-------+-------|            |-------+-------+-------+-------+-------+
	                          TRNS,   TRNS,                TRNS,   TRNS
//                        |-------+-------|            |-------+-------|

//row
//D7, C6, D4, D0, D1
//
//col
//B4, B5, B3, B2, B6, B1, F7, F6, F5, F4
*/